{
                                o

                                1994/12/06  a
}


program Pascalc;
type
   CalcResult = (ClSuccess,                       { I         }
                 ClSyntaxError,                   { vZ }
                 CLDivideError);                  { OŏZ         }
   Result = (Success, Failure);

type
   ValueType = real;

type
   VariableP = ^Variable;
   Variable = object
      name : string;
      Value : ValueType;
      constructor Init(n : string; V : ValueType);
      procedure GetName(var n : string);
      procedure SetVal(V : ValueType);
      function GetVal : ValueType;
   end;

   constructor Variable.Init(n : string; V : ValueType);
   begin
      name := n;
      SetVal(V);
   end;

   procedure Variable.GetName(var n : string);
   begin
      n := name;
   end;

   procedure Variable.SetVal(V : ValueType);
   begin
      Value := V;
   end;

   function Variable.GetVal : ValueType;
   begin
      GetVal := Value;
   end;

type
   VariableTreeP = ^VariableTree;
   VariableTree = Object(Variable)
      small, large : VariableTreeP;
      constructor Init(n : string; v : ValueType);
      function GetTree(n : string; var v : ValueType) : Result;
      function SetTree(n : string; v : ValueType) : Result;
   end;

   constructor VariableTree.Init(n : string; v : ValueType);
   begin
      name := n;
      SetVal(v);
      small := nil;
      large := nil;
   end;

   function VariableTree.GetTree(n : string; var v : ValueType) : Result;
   var
      ret : result;
   begin
      ret := Success;
      if (n = name) then begin
         v := GetVal;
         ret := Success;
      end
      else begin
         if (n > name) then begin
            if (large = nil) then
               ret := Failure
            else
               ret := large^.GetTree(n, v);
         end
         else begin
            if (small = nil) then
               ret := Failure
            else
               ret := small^.GetTree(n, v);
         end;
      end;
      GetTree := ret;
   end;

   function VariableTree.SetTree(n : string; v : ValueType) : Result;
   var
      ret : result;
   begin
      if (n = name) then begin
         SetVal(v);
         ret := Success;
      end
      else begin
         if (n > name) then begin
            if (large = nil) then begin
               new(large);
               if (large = nil) then
                  ret := Failure
               else
                  large^.Init(n, v);
            end
            else
               large^.SetTree(n, v);

         end
         else begin
            if (small = nil) then begin
               new(small);
               if (small = nil) then
                  ret := Failure
               else
                  small^.Init(n, v);
            end
            else
               small^.SetTree(n, v);
         end;
      end;
      SetTree := ret;
   end;


   { 񒆂ŏʂ̃yAT }
   function FindPair(str : string; i : integer) : integer;
   var
      pDepth : integer;                         { ʂ̐[   }
      len    : integer;                         { ̒ }
   begin
      if (str[i] <> '(') then begin
         FindPair := -1;
      end
      else begin
         pDepth := 1;
         len := length(str);
         while (pDepth > 0) and (i <= len) do begin
            i := i + 1;
            case str[i] of
            '(' :
               pDepth := pDepth + 1;
            ')' :
               pDepth := pDepth - 1;
            end;
         end;
         if (pDepth = 0) then
            FindPair := i
         else
            FindPair := -1;
      end;
   end;

   { 񒆂ōłD揇ʂ̒ႢZqԂ }
   function FindLowOperator(str : string) : integer;
   type
      ValState = (NO,                           { łȂ         }
                  MIDDLE,                       { ݒn͐       }
                  AFTER);                       { ̌           }
   var
      i       : integer;                        { ̓Y     }
      op      : integer;                        { Zq̈ʒu       }
      yusen   : integer;                        { Zq̗D揇   }
      len     : integer;                        { ̒       }
      error   : BOOLEAN;                        { G[         }
      ValStat : ValState;                       { ݂͐H     }
   begin
      i := 1;
      yusen := -1;
      op := -1;
      len := length(str);
      error := FALSE;
      ValStat := NO;
      while (i <= len) and (error = FALSE) do begin
         case str[i] of
         '0'..'9', '.', 'A'..'Z', 'a'..'z', '_':
            ValStat := MIDDLE;
         ' ':
            if (ValStat = MIDDLE) then
               ValStat := AFTER;
         '+', '-':
            if (yusen <= 5) and (ValStat <> NO) then begin
               op := i;
               yusen := 5;
               ValStat := NO;
            end
            else begin
               if (yusen <= 2) then begin
                  op := i;
                  yusen := 2;
                  ValStat := NO;
               end
            end;
         '*', '/':
            if (yusen <= 4) and (ValStat <> NO) then begin
               op := i;
               yusen := 4;
               ValStat := NO;
            end;

         '=':
            if (yusen <= 15) then begin
               op := i;
               yusen := 15;
               ValStat := NO;
            end;
         '(':
            begin
               i := findPair(str, i);
               ValStat := MIDDLE;
               if (i = -1) then
                  error := TRUE;
            end;
         else
            ValStat := NO;
         end;
         i := i + 1;
      end;
      if (error = FALSE) then
         FindLowOperator := op
      else
         FindLowOperator := -1
   end;

   { \킷ǂ̌ }
   function isDigit(c : char) : BOOLEAN;
   begin
      case c of
      '0'..'9':
         begin
            isDigit := TRUE;
         end
      else
         begin
            isDigit := FALSE;
         end;
      end;
   end;

   { 񂪐\킹邩ǂ̌ }
   function isNumStr(str : string) : BOOLEAN;
   var
      i     : integer;                          { ̓Y       }
      pFlag : BOOLEAN;                          { _oH }
      len   : integer;                          { ̒         }
      is    : BOOLEAN;                          { ߂l               }
   begin
      len := length(str);
      if (len = 0) then
        is := FALSE
      else begin
         i := 1;
         pFlag := FALSE;
         is := TRUE;
         while ((i <= len) and (is = TRUE)) do begin
            case str[i] of
            '0'..'9':
               ;
            '.':
               if (pFlag = FALSE) then
                  pFlag := TRUE;
            else
               is := FALSE;
            end;
            i := i + 1;
         end;
      end;
      isNumStr := is;
   end;

   {  ValueType ɕϊ }
   function Str2Num(str : string) : ValueType;
   var
      i   : integer;                            { ̓Y   }
      v   : ValueType;                          { ̒l       }
      w   : ValueType;                          { _̈ʎp }
      len : integer;                            { ̒     }
   begin
      i := 1;
      len := length(str);
      v := 0;

      while (isDigit(str[i]) = TRUE) and (i <= len) do begin
         v := v * 10;
         v := v + ord(str[i]) - ord('0');
         i := i + 1;
      end;
      if (str[i] = '.') and (i <= len) then begin
         w := 0.1;
         i := i + 1;
         while (isDigit(str[i])) and (i <= len) do begin
            v := v + (ord(str[i]) - ord('0')) * w;
            w := w * 0.1;
            i := i + 1;
         end;
      end;
      Str2Num := v;
   end;

   { vZp̑Oɂsvȋ󔒂̏ }
   procedure DelSpace(var Str : string);
   var
      len : integer;                            { ̒ }
   begin
      len := length(str);
      while (str[len] = ' ') do begin
         Delete(str, len, 1);
         len := len - 1;
      end;
      while (str[1] = ' ') do begin
         Delete(str, 1, 1);
      end;
   end;

   { vZpɂ͂銇ʁi󔒂܂ށjOB }
   procedure DelParenthesis(var Str : string);
   var
      DelFlag : BOOLEAN;                 { ̃[vŊʂH }
      len     : integer;                 { ̒                   }
   begin
      repeat
         DelFlag := FALSE;
         DelSpace(str);
         if (str[1] = '(') then begin
            len := FindPair(Str, 1);
            if (len = length(Str)) then begin
               Delete(Str, len, 1);
               Delete(Str, 1, 1);
               DelFlag := TRUE;
            end;
         end;
      until (DelFlag = FALSE);
   end;

   function isIdentifier(str : string) : BOOLEAN;
   var
      len : integer;
      i   : integer;
      is  : BOOLEAN;
   begin
      is := TRUE;
      len := length(str);
      if (len = 0) then
         is := FALSE
      else begin
         if (str[1] in ['A'..'Z', 'a'..'z']) then begin
            i := 2;
            while (i <= len) and (is = TRUE) do begin
               if (str[i] in ['A'..'Z', 'a'..'z', '0'..'9']) then begin
                  ;
               end
               else
                  is := FALSE;
               i := i + 1;
            end;
         end
         else
            is := FALSE;
      end;
      isIdentifier := is;
   end;

var
   VarS : VariableTree;

   { vZ̕Z }
   function calc(Str : string; var Ans : ValueType) : CalcResult;
   var
      WorkS   : string;                         { ꎞ̌vZp   }
      Val1    : ValueType;                      { Zq̍̒l       }
      Val2    : ValueType;                      { Zq̉E̒l       }
      op      : integer;                        { Zq̈ʒu         }
      error   : CalcResult;                     { G[ԁi߂lj }
   begin
      DelParenthesis(Str);
      if (isNumStr(Str) = TRUE) then begin  { ݂̂̕񂩁H }
         Ans := Str2num(Str);
         error := ClSuccess;
      end
      else begin
         error := ClSuccess;
         op := FindLowOperator(Str);        { Zq̈ʒu }
         if (op < 0) then begin
            if (isIdentifier(str) = TRUE) then begin
               if (Vars.GetTree(Str, Ans) <> Success) then begin
                  error := ClSyntaxError;
               end;
            end
            else begin
               error := ClSyntaxError;
            end;
         end
         else begin   { Zq̍E̒l }
            if (op = 1)  and ((Str[op] = '+') or (Str[op] = '-')) then begin
               Val1 := 0.0;
            end
            else begin
               WorkS := copy(Str, 1, op - 1);
               if (Str[op] <> '=') then
                  error := calc(WorkS, Val1)
               else
                  DelSpace(WorkS);
            end;
            if (error = ClSuccess) then begin
               WorkS := copy(Str, op + 1, length(Str));
               error := calc(WorkS, Val2);
            end;
         end;
         if (error = ClSuccess) then begin        { Z }
            case Str[op] of
            '+':
               Ans := Val1 + Val2;
            '-':
               Ans := Val1 - Val2;
            '*':
               Ans := Val1 * Val2;
            '/':
               if (Val2 <> 0.0) then
                  Ans := Val1 / Val2
               else
                  error := ClDivideError;
            '=':
               begin
                  WorkS := copy(Str, 1, op - 1);
                  delspace(WorkS);
                  if (isIdentifier(WorkS) = TRUE) then begin
                     VarS.SetTree(WorkS, Val2);
                     ans := Val2;
                  end
                  else
                     error := ClSyntaxError;
               end;
            end;
         end;
      end;
      calc := error;
   end;

   procedure WriteVal(Val : ValueType);
   begin
      if (Trunc(Val) <> Val) then
         write(Val)
      else
         write(Trunc(Val));
   end;


var
   str : string;                                { vZΏۂ̕  }
   ret : CalcResult;                            { calc ֐̖߂l }
   ans : ValueType;                             { vZ          }
begin
   writeln('Pascalc Version 0.01 Copyright(C) 1994  by m.matsubara');
   writeln;

   VarS.Init('pi', 3.141592653589793);
   readln(str);
   while (str[1] <> '.') do begin
      ret := calc(str, ans);
      case ret of
      ClSuccess:
         begin
            write(' = ');
            {writeln(ans:0:0);}

            WriteVal(ans);
            writeln;
         end;
      ClSyntaxError:
         writeln('Syntax Error');
      ClDivideError:
         writeln('Divide Error');
      end;
      readln(str);
   end;
end.







{ Copyright(C) 1994  by m.matsubara }
